#version 330

in vec4 position;
in vec3 normal;
in vec2 texture;
in ivec4 boneId;
in vec4 boneWeight;

const int BONE_MAX = 100;


uniform mat4 mvp;
uniform mat4 bones[BONE_MAX];

void main()
{
	if(boneWeight[0] > 0){
		mat4 finalTransformation = bones[boneId[0]] * boneWeight[0];
		finalTransformation += bones[boneId[1]] * boneWeight[1];
		finalTransformation += bones[boneId[2]] * boneWeight[2];
		finalTransformation += bones[boneId[3]] * boneWeight[3];
		gl_Position = mvp * finalTransformation * position;
	}else{
		gl_Position = mvp * position;
	}
}