#version 420

in vec4 position;
in vec3 normal;
in vec2 texture;
in ivec4 boneId;
in vec4 boneWeight;

out vec2 uv;
smooth out vec3 worldNormal;  // Interpolated normal vector in world space
out vec3 worldPosition;	// Vertexposition in worldspace
out vec4 smCoords[4];
out float fog_dot_Vertex;
out float fog_dot_Camera;
out vec3 rho_Camera;

const int BONE_MAX = 100;

uniform mat4 mvp;
uniform mat4 model;
uniform mat4 lightMVP1;
uniform mat4 lightMVP2;
uniform mat4 lightMVP3;
uniform mat4 lightMVP4;
uniform vec3 worldEye;
uniform vec4 fogHalfspace;
uniform float fogIntensity;
uniform mat4 bones[BONE_MAX];

void main()
{
	//mat4 finalTransformation = bones[boneId[0]] * boneWeight[0];
	//finalTransformation += bones[boneId[1]] * boneWeight[1];
	//finalTransformation += bones[boneId[2]] * boneWeight[2];
	//finalTransformation += bones[boneId[3]] * boneWeight[3];

	gl_Position = mvp *  position;
	smCoords[0] = lightMVP1 * position;
	smCoords[1] = lightMVP2 * position;
	smCoords[2] = lightMVP3 * position;
	smCoords[3] = lightMVP4 * position;
	uv = texture;
	
	worldNormal = (model * vec4(normal, 0.0f)).xyz;
	vec4 worldPosition4f = (model * position);
	worldPosition = worldPosition4f.xyz;

	vec4 camera = model * vec4(worldEye, 0.0f);
	fog_dot_Vertex = dot(fogHalfspace, worldPosition4f);
	fog_dot_Camera = dot(fogHalfspace, camera);
	rho_Camera = fogIntensity * camera.xyz;
}