#version 330 core

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec2 position;
layout(location = 1) in vec2 texture;

// Output data ; will be interpolated for each fragment.
out vec2 UV;

uniform int widthHalf;
uniform int heightHalf;

void main(){
	// Output position of the vertex, in clip space
	vec2 positionHomo = position - vec2(widthHalf, heightHalf);
	positionHomo /= vec2(widthHalf, heightHalf);
	gl_Position = vec4(positionHomo, 0, 1);

	// UV of the vertex. No special space for this one.
	UV = texture;
}

